
#ifndef PARSECQT5COMMON_H
#define PARSECQT5COMMON_H

#include "parsec_common_qt5_global.h"

#include "iconprovider.h"
#include "desktopintegrationplugin.h"

#define PARSECQT5_ICON(id) ParsecQt5::Common::ptr()->iconProvider()->iconById( id )
#define PARSECQT5_MERGED_ICON(idf,idb) ParsecQt5::Common::ptr()->iconProvider()->mergedIconByIds( idf, idb )

#define PARSECQT5_LOW_UID 300
#define PARSECQT5_LOW_GID 300

namespace ParsecQt5
{
    class PARSEC_COMMON_QT5_EXPORT Common
    {
    public:

        static Common *ptr();
        ~Common();

        void callApplicationHelpWindow( QWidget *parent, VariantMap args );
        void callApplicationAboutWindow( QWidget *parent, VariantMap args );
        IconProvider *iconProvider();

        static QString uniqueName( const QString &base, const QStringList &list );
        static QString nameByUid( uid_t uid, bool *ok = NULL );
        static QString nameByGid( gid_t gid, bool *ok = NULL );
        static uid_t uidByName( const QString &name, bool *ok = NULL );
        static gid_t gidByName( const QString &name, bool *ok = NULL );
        static QString homeDirByUid( uid_t uid );
        static int userCount( unsigned int low = 0 );
        static int groupCount( unsigned int low = 0 );
///DUMMY
///        static QMap<QString,QVariant> users();
///        static QMap<QString,QVariant> groups();
        QString shortedString( const QString &string, int max = 10 );

    private:

        Common();
        static Common *m_ptr;
        DesktopIntegrationPlugin *m_desktopIntegrationPlugin;
        IconProvider *m_iconProvider;
    };
}

#endif // PARSECQT5COMMON_H
