/*

  Author(s): Ilja V. Ryndin (ryndin@pinebrush.com)

  Start date: *

*/

#ifndef POPUPWIDGET_H
#define POPUPWIDGET_H

#include "parsec_common_qt5_global.h"

#include <QFrame>

namespace ParsecQt5
{
    class PARSEC_COMMON_QT5_EXPORT PopupWidget : public QFrame
    {
    Q_OBJECT

    public:

        enum Mode { LeaveMouseAcceptMode = 0, DeactivateWindowAcceptMode = 1 };

        PopupWidget( Mode mode = LeaveMouseAcceptMode, QWidget *parent = nullptr );
        virtual ~PopupWidget();
        void setWidget( QWidget *widget );

    public slots:

        void popup();
        void popup( const QPoint &pos );
        void accept();

    signals:
        void done();

    protected:
        void mouseDoubleClickEvent( QMouseEvent *e ) override;
        void leaveEvent( QEvent *e ) override;
        bool event( QEvent *e ) override;

    private:
        QWidget *m_widget;
        Mode m_mode;
    };
}

#endif // POPUPWIDGET_H
